SystemOrganization addCategory: #SONiklasBContest!

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 19:06'!
find1Singleton
	^self find1SingletonBaseMask: 0 baseValue: 0 baseSum: self xorSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 19:06'!
find1SingletonBaseMask: baseMask baseValue: baseValue baseSum: baseSum
	^{baseSum}! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 19:03'!
find2Singleton
	^self find2SingletonBaseMask: 0 baseValue: 0 baseSum: self xorSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 19:48'!
find2SingletonBaseMask: baseMask baseValue: baseValue baseSum: baseSum
	| lowestBit split |
	lowestBit := baseSum bitAnd: baseSum negated.
	split := BinarySplit split: self withMask: lowestBit + baseMask value1: baseValue value2: lowestBit + baseValue.
	^{split sum1. split sum2}! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 20:23'!
find3Singleton
	^self find3SingletonFromBit: 0 baseMask: 0 baseValue: 0 baseSum: self xorSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 20:20'!
find3SingletonFromBit: i baseMask: baseMask baseValue: baseValue baseSum: baseSum
	| split |
	split := BinarySplit split: self withMask: 1 << i + baseMask value1: baseValue value2: 1 << i + baseValue.
	^(split doesSplitInto: 0 and: baseSum)
		ifTrue: [self find3SingletonFromBit: i + 1 baseMask: baseMask baseValue: baseValue baseSum: baseSum]
		ifFalse:
			[split size1 odd
				ifTrue: [{split sum1}
					, (self find2SingletonBaseMask: 1 << i + baseMask baseValue: 1 << i + baseValue baseSum: split sum2)]
				ifFalse: [{split sum2}
					, (self find2SingletonBaseMask: 1 << i + baseMask baseValue: baseValue baseSum: split sum1)]]! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 20:23'!
find4Singleton
	^self find4SingletonFromBit: 0 baseMask: 0 baseValue: 0 baseSum: self xorSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 20:21'!
find4SingletonFromBit: i baseMask: baseMask baseValue: baseValue baseSum: baseSum
	| split |
	split := BinarySplit split: self withMask: 1 << i + baseMask value1: baseValue value2: 1 << i + baseValue.
	split size1 odd
		ifTrue: [^(self occurrencesOf: split sum1) = 1
			ifTrue: [{split sum1}
				, (self find3SingletonFromBit: i + 1 baseMask: 1 << i + baseMask baseValue: 1 << i + baseValue baseSum: split sum2)]
			ifFalse: [{split sum2}
				, (self find3SingletonFromBit: i + 1 baseMask: 1 << i + baseMask baseValue: baseValue baseSum: split sum1)]].
	(split doesSplitInto: 0 and: baseSum)
		ifFalse:
			[^(self find2SingletonBaseMask: 1 << i + baseMask baseValue: baseValue baseSum: split sum1)
				, (self find2SingletonBaseMask: 1 << i + baseMask baseValue: 1 << i + baseValue baseSum: split sum2)].
	^self find4SingletonFromBit: i + 1 baseMask: baseMask baseValue: baseValue baseSum: baseSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 20:23'!
find5Singleton
	^self find5SingletonFromBit: 0 baseMask: 0 baseValue: 0 baseSum: self xorSum! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 20:23'!
find5SingletonFromBit: i baseMask: baseMask baseValue: baseValue baseSum: baseSum
	| split |
	split := BinarySplit split: self withMask: 1 << i + baseMask value1: baseValue value2: 1 << i + baseValue.
	^(split doesSplitInto: 0 and: baseSum)
		 ifTrue:
			["Either (0,5) or (2,3) if xor(3)=0 which is possible with 2r011 2r101 2r110"
			baseSum = 0
				ifTrue: ["It can't be (2,3) because xor(2) cannot be zero"]
				ifFalse:
					[(split sum1 = baseSum and: [split size1 even])
						ifTrue: [^(self find2SingletonBaseMask: 1 << i + baseMask baseValue: baseValue baseSum: split sum1)
							, (self find3SingletonFromBit: i + 1 baseMask: 1 << i + baseMask baseValue: 1 << i + baseValue baseSum: split sum2)].
					(split sum2 = baseSum and: [split size2 even])
						ifTrue: [^(self find3SingletonFromBit: i + 1 baseMask: 1 << i + baseMask baseValue: baseValue baseSum: split sum1)
							, (self find2SingletonBaseMask: 1 << i + baseMask baseValue: 1 << i + baseValue baseSum: split sum2)]].
			self find5SingletonFromBit: i baseMask: baseMask baseValue: baseValue baseSum: baseSum]
		ifFalse:
			["Either (1,4) or (2,3)"
			| inc1 inc2 |
			inc1 := (self occurrencesOf: split sum1) = 1.
			inc2 := (self occurrencesOf: split sum2) = 1.
			(inc1 or: [inc2])
				ifTrue: [split size1 odd
					ifTrue: [{split sum1} , (self find4SingletonFromBit: i + 1 baseMask: 1 << i + baseMask baseValue: 1 << i + baseValue baseSum: split sum2)]
					ifFalse: [{split sum2} , (self find4SingletonFromBit: i + 1 baseMask: 1 << i + baseMask baseValue: baseValue baseSum: split sum1)]]
				ifFalse: [split size1 even
					ifTrue: [(self find2SingletonBaseMask: 1 << i + baseMask baseValue: baseValue baseSum: split sum1)
							, (self find3SingletonFromBit: i + 1 baseMask: 1 << i + baseMask baseValue: 1 << i + baseValue baseSum: split sum2)]
					ifFalse: [(self find3SingletonFromBit: i + 1 baseMask: 1 << i + baseMask baseValue: baseValue baseSum: split sum1)
							, (self find2SingletonBaseMask: 1 << i + baseMask baseValue: 1 << i + baseValue baseSum: split sum2)]]]! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 20:17'!
testSingleton
	self assert: {0. 3. 5. 2. 5. 4. 3. 0. 2.} find1Singleton = {4}.
	self assert: {0. 1. 1. 3. 5. 6. 2. 6. 4. 3. 0. 2.} find2Singleton sorted = {4. 5}.
	self assert: {0. 1. 3. 5. 6. 2. 6. 4. 3. 0. 2.} find3Singleton sorted = {1. 4. 5}.
	self assert: {9. 10. 5. 6. 32. 32} find4Singleton sorted = {5. 6. 9. 10.}.
	self assert: {0. 1. 3. 5. 9. 6. 2. 6. 4. 3. 0. 2.} find4Singleton  sorted = {1. 4. 5. 9.}.
	self assert: {0. 1. 12. 3. 5. 9. 6. 2. 6. 4. 3. 0. 2.} find5Singleton sorted = {1. 4. 5. 9. 12.}.! !

!Collection methodsFor: '*SONiklasBContest' stamp: 'nice 8/17/2012 19:03'!
xorSum
	^self inject: 0 into: [:sum :element | element bitXor: sum]! !

Object subclass: #BinarySplit
	instanceVariableNames: 'sum1 sum2 size1 size2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SONiklasBContest'!

!BinarySplit class methodsFor: 'instance creation' stamp: 'nice 8/17/2012 17:21'!
split: aSequence withMask: aMask value1: value1 value2: value2
	^self new split: aSequence withMask: aMask value1: value1 value2: value2! !

!BinarySplit methodsFor: 'accessing' stamp: 'nice 8/17/2012 17:20'!
doesSplitInto: s1 and: s2
        ^(sum1 = s1 and: [sum2 = s2])
            or: [sum1 = s2 and: [sum2 = s1]]! !

!BinarySplit methodsFor: 'accessing' stamp: 'nice 8/17/2012 17:19'!
size1
        ^size1! !

!BinarySplit methodsFor: 'accessing' stamp: 'nice 8/17/2012 17:19'!
size2
        ^size2! !

!BinarySplit methodsFor: 'accessing' stamp: 'nice 8/17/2012 17:20'!
split: aSequence withMask: aMask value1: value1 value2: value2
        sum1 := sum2 := size1 := size2 := 0.
        aSequence do: [:element |
	    (element bitAnd: aMask) = value1
                ifTrue:
                    [sum1 := sum1 bitXor: element.
                    size1 := size1 + 1].
	    (element bitAnd: aMask) = value2
                ifTrue:
                    [sum2 := sum2 bitXor: element.
                    size2 := size2 + 1]].! !

!BinarySplit methodsFor: 'accessing' stamp: 'nice 8/17/2012 17:19'!
sum1
        ^sum1! !

!BinarySplit methodsFor: 'accessing' stamp: 'nice 8/17/2012 17:19'!
sum2
        ^sum2! !
